// Sparta-Mod - Handle Say

public eventSay( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	static talk[128];
	read_args( talk, charsmax( talk ) );
	
	// The player said savexp
	if ( contain( talk, "savexp" ) != -1 )
	{
		SaveXPCommand( id );
	}
	
	// He want to see which level, xps and ultimate he has
	else if ( contain( talk, "level" ) != -1 )
	{
		LevelCommand( id );
	}
	
	// He want another ultimate
	else if ( contain( talk, "resetultimate" ) != -1 )
	{
		ResetUltCommand( id );
	}
	
	// He want the Sparta-Menu
	else if ( contain( talk, "spartamenu" ) != -1 ) 
	{
		ShowSpartaMenu( id );
	}
	
	// show the level's and the ultimates from the players on the server
	else if ( contain( talk, "showplayers" ) != -1 )
	{
		ShowMotd( id, 4 );
	}
	
	// show how many xps a player have to level up
	else if ( contain( talk, "showxptables" ) != -1 )
	{
		client_print ( id, print_chat, "%s Look in your console to see the xptables", SPARTA_NAME );
		ShowMotd( id, 5 );
	}
	
	// reset the xps
	else if ( contain( talk, "resetxp" ) != -1 )
	{
		ResetXPs( id );
	}
	
	// Reset skills
	else if ( contain( talk, "resetskills" ) != -1 )
	{
		ResetAllSkills( id );
	}
	
	// Select a ultimate
	else if ( contain( talk, "selectultimate" ) != -1 )
	{
		SelectUltimateConc( id );
	}
	
	// Select a skill
	else if ( contain( talk, "selectskill" ) != -1 )
	{
		SelectSkillConc( id );
	}
	
	// select an item
	else if ( contain( talk, "utilmenu" ) != -1 || contain( talk, "utilmenu1" ) != -1 )
	{
		ShowUtilMenuOne( id );
	}
	
	return PLUGIN_CONTINUE;
}

public SelectUltimateConc( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Ultimates important. Select one!
	if ( Player_Ultimate[id] == 0 && Player_Level[id] >= Ultimate_REQLevel[1] && !is_user_bot( id ) )
	{
		set_task ( 0.4, "SelectUltimate", ( TASK_SET_ULT + id ) );
	}
		
	// The player can't choose a ultimate
	else
	{
		client_print( id, print_chat, "%s You can't choose an ultimate yet", SPARTA_NAME );
	}
	
	return PLUGIN_HANDLED;
}

public SelectSkillConc( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}

	// Has the player a available skillpoint?
	if ( Player_SkillData[id][AVAILABLE_SKILLS] > 0 && !is_user_bot( id ) )
	{
		// Show the menu with the first (0) side
		ChooseSkill( id, 0 );
	}
		
	// The player can't choose a skill
	else
	{
		client_print( id, print_chat, "%s You haven't an skillpoint yet", SPARTA_NAME );
	}
	
	return PLUGIN_HANDLED;
}

public ShowPlayersConc( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	ShowMotd( id, 4 );
	
	return PLUGIN_HANDLED;
}

public ShowXPTablesConc( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	ShowMotd( id, 5 );
	
	return PLUGIN_HANDLED;
}

public SaveXPCommand( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	if ( !get_pcvar_num( sp_savexp ) )
	{
		client_print ( id, print_chat, "%s SaveXP is disabled by the administrator", SPARTA_NAME );
		return PLUGIN_HANDLED;
	}
		
	// save the xps
	SavePlayerXP( id );
	
	return PLUGIN_HANDLED;
}

public ResetXPs( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Reset XP all data
	Player_XPs[id] = 0;
	Player_Level[id] = 0;
	Player_Ultimate[id] = 0;
	
	// Show him the new bar
	PlayerShowBar( id );
	
	client_print ( id, print_chat, "%s Your XPs are reseted", SPARTA_NAME );
	
	return PLUGIN_HANDLED;
}

public LevelCommand( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	// Print him some informations 
	client_print ( id, print_chat, "%s You have %d XP and you are on Level %d", SPARTA_NAME, Player_XPs[id], Player_Level[id] );
	client_print ( id, print_chat, "%s Your ultimate is %s", SPARTA_NAME, Ultimate_Names[Player_Ultimate[id]] );
	client_print ( id, print_chat, "%s Levitation: %d; Invisibility: %d; Speed: %d; Health: %d", SPARTA_NAME, Player_Skill[id][0], Player_Skill[id][1], Player_Skill[id][2], Player_Skill[id][3] );
	
	return PLUGIN_HANDLED;
}

public ResetUltCommand( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	//  Remove the icon
	HandleIcon( id, 0 );
	
	// We set it to 0 = None
	Player_Ultimate[id] = 0;
	
	// Ultimates important. Select one!
	if ( Player_Level[id] >= Ultimate_REQLevel[1] && !is_user_bot( id ) )
	{
		set_task ( 0.4, "SelectUltimate", ( TASK_SET_ULT + id ) );
	}
		
	// the player haven't the right level for the ultimates
	else
	{
		client_print ( id, print_chat, "%s You haven't an ultimate yet", SPARTA_NAME );
	}
	
	return PLUGIN_HANDLED;
}

public ShowSpartaMenu( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	static MenuText[256];
	formatex ( MenuText, charsmax( MenuText ), "\ySparta-Mod Menu\w^n^n" );
	
	// First we add a menu point for help
	formatex ( MenuText, charsmax( MenuText ), "%s1. Help^n", MenuText );
	
	// Then we add a menu point for commands
	formatex ( MenuText, charsmax( MenuText ), "%s2. Commands^n", MenuText );
	
	// We shouldn't forget a menu point for credits
	formatex ( MenuText, charsmax( MenuText ), "%s3. Credits^n", MenuText );
	
	// A menu point for exit
	formatex ( MenuText, charsmax( MenuText ), "%s^n4. Exit", MenuText );
	
	// Here we add the keys for the menu.
	static KEY;
	KEY = MENU_KEY_1 | MENU_KEY_2 | MENU_KEY_3 | MENU_KEY_4;
	
	// Show the menu to the player
	show_menu ( id, KEY, MenuText, 15, "ShowSPMenu" );
	
	return PLUGIN_HANDLED;
}

public SetSPMenuOption( id, key )
{
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// We have to add one to the key
	key++;
	
	switch ( key )
	{
		case 1: // He wants the help motd
		{
			ShowMotd( id, 1 );
		}
		
		case 2: // He wants the commands motd
		{
			ShowMotd( id, 2 );
		}
		
		case 3: // He wants the credits motd
		{
			ShowMotd( id, 3 );
		}
	}
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
