// Other Stuff

// Strip all weapons (thanks again to cheap_suit)
stock fm_strip_user_weapons( id ) 
{
	static stripent;
	if ( !pev_valid( stripent ) )
	{
		stripent = engfunc ( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "player_weaponstrip" ) );
		dllfunc ( DLLFunc_Spawn, stripent );
		set_pev ( stripent, pev_solid, SOLID_NOT );
	}
	dllfunc ( DLLFunc_Use, stripent, id );
}

public Strip_Player_Weapons( id )
{
	if ( !is_user_alive ( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Set the speed from the player when the freezetime is over
	if ( g_FreezeTimeOver )
	{
		Skill_SetSpeed( id + TASK_SPEED );
	}
	
	// Set the invisibility
	Skill_Invisible( id );
	
	// Get player current weapon
	static weapon;
	weapon = get_user_weapon ( id );
	
	if ( weapon == CSW_C4 )
	{
		// The player who spawned with the bomb should get xps
		if ( g_PlayerSpawnBomb == 0 )
		{
			// Only once per round
			g_PlayerSpawnBomb = id;
			
			static XPs;
			
			// Get the right XPs
			XPs = get_pcvar_num( sp_spawnbomb );
		
			// Set him as Bomb carrier
			g_PlayerRole[id] = PLR_BOMBCARRIER;
		
			// RoundStart is to low, we have to give xp although the round is over
			g_GiveEndRoundXP = true;
			GivePlayerXP( id, XPs );
			
			if ( Player_Level[id] != MAX_LEVEL )
			{
				// Send the player a Message
				client_print( id, print_chat, "%s You have been awarded %d XP for spawning with the bomb", SPARTA_NAME, XPs );
			}
		}
	}

	// We shouldn't drop the Weapons if we have the bomb or a knife in the hand and if the task allready running & we have a hegrenade
	if ( weapon != CSW_HEGRENADE && weapon != CSW_KNIFE && weapon != CSW_C4 && !task_exists( TASK_STRIP + id ) )
	{
		set_task ( 0.2, "task_stripngive", TASK_STRIP + id );
		return PLUGIN_CONTINUE;
	}
	return PLUGIN_CONTINUE;
}

// The Weapons should be stripped 
public task_stripngive( taskid )
{
	static id;
	id = taskid - TASK_STRIP;
	
	if ( !is_user_alive ( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// If the User has the bomb, he should get it back 
	if ( user_has_weapon ( id, CSW_C4 ) )
	{
		g_Bombcarrier = id;
	}
	
	// The player has a nade. Give it him back
	static bool:GiveUserNade;
	if ( user_has_weapon ( id, CSW_HEGRENADE ) )
	{
		GiveUserNade = true;
	}
		
			
	// Strip all weapons from the User and give him a knife & bomb & maybe a defuse
	fm_strip_user_weapons ( id );
	
	if ( g_Bombcarrier == id )
	{
		set_task ( 0.5, "Give_User_Bomb", TASK_BOMB + id );
	}
	
	// Give the user the knife. This is later our blade
	bacon_give_weapon ( id, "weapon_knife" );
	
	// The player should have a hegrenade (from item) Give it him back
	if ( GiveUserNade )
	{
		set_task ( 1.0, "ITEM_HeGrenade", ( id + TASK_NADE ) );
	}
	
	// Give him a defusekit if he is a ct
	if ( get_user_team( id ) == TEAM_CT && !task_exists( id + TASK_GIVEDEFUSE ) )
	{
		set_task ( 2.5, "GivePlayerDefuse", ( id + TASK_GIVEDEFUSE ) );
	}
	
	 //Remove Shield if player has one (GHW)
	if ( cs_get_user_shield( id ) )
	{
		client_cmd ( id, "drop" );
		set_task( 0.2, "task_stripshield", TASK_SHIELD + id );
	}

	
	return PLUGIN_CONTINUE;
}

// Give the player the bomb back
public Give_User_Bomb( taskid )
{
	// Get the ID
	taskid -= TASK_BOMB;
	
	if ( !is_user_connected( taskid ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Give him a weapon
	bacon_give_weapon ( taskid, "weapon_c4" );
	
	// The bomb isn't activ if we don't do this
	cs_set_user_plant ( taskid, 1, 1 );
	
	// No more bombs
	g_Bombcarrier = 0;
	
	return PLUGIN_CONTINUE;
}

// Thanks to cheap_suit. Usefull function from Biohazard.
stock bacon_give_weapon(index, weapon[])
{
	static ent; ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, weapon))
	if(!pev_valid(ent)) return 0
    
	set_pev(ent, pev_spawnflags, SF_NORESPAWN)
	dllfunc(DLLFunc_Spawn, ent)
   
	if(!ExecuteHamB(Ham_AddPlayerItem, index, ent))
	{
		if(pev_valid(ent)) set_pev(ent, pev_flags, pev(ent, pev_flags) | FL_KILLME)
		return 0
	}
	ExecuteHamB(Ham_Item_AttachToPlayer, ent, index)

	return 1
}

// Show all Players the Statusbar
public ShowAllStatusBar()
{
	static players[32], num, i;
	
	// Get the players for the Statusbar
	get_players ( players, num, "a" );
	
	// Give all alive players a statusbar
	for ( i = 0; i < num; ++i )
	{
		if ( is_user_alive( players[i] ) )
		{
			PlayerShowBar( players[i] );
		}
	}
}

// This is from the "CHR Engine". Thanks to GHW_Chronic
stock entity_set_aim(ent,const Float:origin2[3],bone=0)
{
	if(!pev_valid(ent))
		return 0;

	static Float:origin[3]
	origin[0] = origin2[0]
	origin[1] = origin2[1]
	origin[2] = origin2[2]

	static Float:ent_origin[3], Float:angles[3]

	if(bone)
		engfunc(EngFunc_GetBonePosition,ent,bone,ent_origin,angles)
	else
		pev(ent,pev_origin,ent_origin)

	origin[0] -= ent_origin[0]
	origin[1] -= ent_origin[1]
	origin[2] -= ent_origin[2]

	static Float:v_length
	v_length = vector_length(origin)

	static Float:aim_vector[3]
	aim_vector[0] = origin[0] / v_length
	aim_vector[1] = origin[1] / v_length
	aim_vector[2] = origin[2] / v_length

	static Float:new_angles[3]
	vector_to_angle(aim_vector,new_angles)

	new_angles[0] *= -1

	if(new_angles[1]>180.0) new_angles[1] -= 360
	if(new_angles[1]<-180.0) new_angles[1] += 360
	if(new_angles[1]==180.0 || new_angles[1]==-180.0) new_angles[1]=-179.999999

	set_pev(ent,pev_angles,new_angles)
	set_pev(ent,pev_fixangle,1)

	return 1;
}

// From CSDM, thanks BAILOPAN
stock RemoveEntityAll(name[])
{
    new ent = engfunc(EngFunc_FindEntityByString, 0, "classname", name)
    new temp
    while (ent)
    {
        temp = engfunc(EngFunc_FindEntityByString, ent, "classname", name)
        engfunc(EngFunc_RemoveEntity, ent)
        ent = temp
    }
}

// From Biohazard, thanks cheap_suit
public bacon_touch_buyzone(ent, id)
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return HAM_IGNORED;
	}
	
	set_pev ( ent, pev_solid, SOLID_NOT );
	return HAM_SUPERCEDE;
}

// Gives a player a defusekit
public GivePlayerDefuse( id )
{
	id -= TASK_GIVEDEFUSE;
	
	if ( !is_user_alive( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Give him the defusekit
	give_item ( id, "item_thighpack" );
	
	return PLUGIN_CONTINUE;
}

//New function - Removes shield entity from map (from GHW_Chronic)
public task_stripshield( id )
{
    new origin[3], classname[32];
    pev(id,pev_origin,origin);
    new ent, ent2;
    new maxplayers = get_maxplayers();
    ent = engfunc(EngFunc_FindEntityInSphere,maxplayers,origin,100.0)
    while(ent)
    {
        pev(ent,pev_classname,classname,31);
        if(equali(classname,"weapon_shield") && pev(ent,pev_owner)==id)
        {
            pev(ent,pev_origin,origin)
            ent2 = engfunc(EngFunc_FindEntityInSphere,maxplayers,origin,100.0);
            while(ent2>0)
            {
                if(pev(ent2,pev_owner)==ent)
                    engfunc(EngFunc_RemoveEntity,ent2);
            }
        }
    }
}

// Is it a grenade or not? (from arkshine)
public bool:IsGrenade ( i_Inflictor )
{
	static s_Classname[ 8 ];
	pev ( i_Inflictor, pev_classname, s_Classname, charsmax ( s_Classname ) );
        
	return equal ( s_Classname, "grenade" ) ? true : false;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
