// Sparta-Mod Ultimate 2 - Blast Wave (code & idea from asskicr)

public BlastWave( id )
{
	id -= TASK_ULTIMATE;
	
	static origin[3], vorigin[3], distance;
	static players[32], num;
	
	static i, bool:s_FoundUser;
	s_FoundUser = false;
	
	new Float:tempVelocity[3] = { 0.0, 0.0, ULTIMATE_HIGH }, parm[4];
	
	// Get the team from the ultimate owner
	static AttackerTeam;
	AttackerTeam = get_user_team( id );
	
	// Get all players
	get_players( players, num );
	
	for ( i = 0; i < num; ++i )
	{
		// Dead player's can't get damage
		if ( !is_user_alive( players[i] ) )
		{
			continue;
		}
		
		// We need all players from the opposite team
		if ( get_user_team( players[i] ) == AttackerTeam )
		{
			continue;
		}
		
		// Get the origin
		get_user_origin ( players[i], vorigin );
		
		// Origin from the player
		get_user_origin ( id, origin );
		
		// Get the distance
		distance = get_distance ( origin, vorigin );
		
		if ( distance < BW_RADIUS )
		{
			// only one time
			if ( !s_FoundUser )
			{
				// Play the sparta sound (THIS IS SPARTA!)
				if ( get_pcvar_num( sp_soundon ) )
				{
					emit_sound( id, CHAN_STATIC, g_Sound[THIS_IS_SPARTA_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
				}
				
				// Handle the icon
				HandleIcon( id, 0 );
				
				// We found someone, ultimate start and he get a cooldown
				Player_UltDelay[id] = get_pcvar_num( sp_ultdelay );
				
				s_FoundUser = true;
			}
			
			// Calculate where we have to kick
			parm[0] = ( ( vorigin[0] - origin[0] ) / distance ) * BW_POWER;
			parm[1] = ( ( vorigin[1] - origin[1] ) / distance ) * BW_POWER;
			parm[2] = players[i];
			parm[3] = id;
			
			// Move the player in the air
			set_pev ( players[i], pev_velocity, tempVelocity );
						
			// The sparta sound is over, now we can kick him 
			set_task ( 0.3, "Move_Enemy", ( players[i] + TASK_ULT_BLAST ), parm, 4 );
		}
	}
	
	// We didn't found a player in range, let us say it to him
	if ( !s_FoundUser )
	{
		UltErrorMessages( id, 3 );
	}
	
	return PLUGIN_HANDLED;
}

// kick the player away and deal some damage
public Move_Enemy( parm[4] )
{
	new victim = parm[2];
	new id = parm[3];
	
	if ( !is_user_alive( victim ) )
	{
		return PLUGIN_HANDLED;
	}
	
	// Shake the screen from the player
	Create_ScreenShake( victim, (10<<12), (2<<12), (10<<12) );

	new Float:fl_velocity[3];
	fl_velocity[0] = float( parm[0] );
	fl_velocity[1] = float( parm[1] );
	fl_velocity[2] = ULTIMATE_HIGH;

	// Push him away
	set_pev ( victim, pev_velocity, fl_velocity );
	
	// play the damage sound
	emit_sound( victim, CHAN_BODY, g_Sound[PAIN_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );

	// deal the damage
	DoDamageToPlayer( id, victim, BW_DMG, 0, 2 );
	
	return PLUGIN_HANDLED;
}

/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
