// Sparta-Mod Ultimate 4 Chainlightning from wc3ft

// Activate the lightning ultimate
public ActivLightning( id )
{
	id -= TASK_ULTIMATE;
	
	// He is searching for an enemy
	if ( Player_SkillData[id][ISSEARCHING] != 1 )
	{
		Player_SkillData[id][ISSEARCHING] = 1;
		
		// Show him the icon
		FlashIcon( id, ULTIMATE_LIGHTNING );
		
		// After a spezific time the ultimate isn't no more ready
		set_task ( 5.0, "ActivLightning", ( id + TASK_ULTIMATE ) );
	}
	
	// He should no more search
	else
	{
		Player_SkillData[id][ISSEARCHING] = 0;
		
		// Stop flashing the icon
		HandleIcon( id, 1 );
	}
}
	

// Initial Ultimate call
public OR_ULT_ChainLightning( iCaster, iTarget )
{

	// Display the lightning effect
	OR_ULT_ChainEffect( iCaster, iTarget, CHAINLIGHTNING_LINEWIDTH, CHAINLIGHTNING_DAMAGE );
	
	// Handle the icon
	HandleIcon( iCaster, 0 );

	// Set the ultimate delay
	Player_UltDelay[iCaster] = get_pcvar_num( sp_ultdelay );
	
	// Set off the task
	if ( task_exists( iCaster + TASK_ULTIMATE ) )
	{
		remove_task( iCaster + TASK_ULTIMATE );
	}
	
	// He does no more search
	Player_SkillData[iCaster][ISSEARCHING] = 0;
	
	// Now we need to search for the next "jump"
	new parm[4];
	parm[0] = iTarget;
	parm[1] = CHAINLIGHTNING_DAMAGE;
	parm[2] = CHAINLIGHTNING_LINEWIDTH;
	parm[3] = iCaster;

	set_task( 0.2, "_OR_ULT_ChainLightning", TASK_LIGHTNING + iTarget, parm, 4 );
}

// Called on subsequent ultimate calls ( i.e. lightninghitnext )
public _OR_ULT_ChainLightning( parm[4] )
{
	// parm[0] = enemy
	// parm[1] = damage
	// parm[2] = linewidth
	// parm[3] = caster
	
	new iEnemy = parm[0];

	if ( !is_user_alive( iEnemy ) )
	{
		return;
	}

	new iCaster	= parm[3];
	new iCasterTeam	= get_user_team( iCaster );

	new vOrigin[3];
	get_user_origin( iEnemy, vOrigin );

	new players[32], numberofplayers;
	get_players( players, numberofplayers, "a" );


	new i, iTarget = 0;
	new iClosestTarget = 0, iClosestDistance = 0;
	new iDistanceBetween = 0;
	new vTargetOrigin[3]

	// Loop through every player
	for ( i = 0; i < numberofplayers; i++ )
	{
		iTarget = players[i];
		
		// Make sure our target player isn't on the same team!
		if ( get_user_team( iTarget ) != iCasterTeam )
		{
			get_user_origin( iTarget, vTargetOrigin )
			
			iDistanceBetween = get_distance( vOrigin, vTargetOrigin );

			// Verify the user is within range and has not been previously hit
			if ( iDistanceBetween < LIGHTNING_RANGE && Player_SkillData[iTarget][LIGHTNINGHIT] != 1 )
			{

				// This user is closest!! Lets make a note of this...
				if ( iDistanceBetween < iClosestDistance || iClosestTarget == 0 )
				{
					iClosestDistance = iDistanceBetween;
					iClosestTarget = iTarget;
				}
			}//end distance/hit check
		}//end team check
	}//end for

	// Then we have a valid target!!!
	if ( iClosestTarget )
	{
		// Damage should be decreased by 2/3 on each jump
		parm[1] = floatround(float(parm[2])*2/3);

		// Decrease line width as well
		parm[2] = floatround(float(parm[2])*2/3);
		
		// Display the actual lightning
		OR_ULT_ChainEffect( iCaster, iClosestTarget, parm[2], parm[1] );

		// Lets call this again on our next target!
		parm[0] = iClosestTarget;
		set_task( 0.2, "_OR_ULT_ChainLightning", TASK_LIGHTNINGNEXT + iCaster, parm, 4 );
	}

	// No valid target found - reset all lightning hit variables
	else
	{
		for ( i = 0; i < numberofplayers; i++ )
		{
			iTarget = players[i];

			Player_SkillData[iTarget][LIGHTNINGHIT] = 0;
		}
	}

	return;
}

public OR_ULT_ChainEffect( iCaster, iTarget, iLineWidth, iDamage )
{

	// Make sure we set this user as hit, otherwise we'll hit him again
	Player_SkillData[iTarget][LIGHTNINGHIT] = 1;
	
	// Damage the user
	DoDamageToPlayer( iCaster, iTarget, iDamage, 0, 2 );
	
	// Create the lightning
	Create_TE_BEAMENTS( iCaster, iTarget, g_Sprites[LIGHTNING_SPRITE], 0, 15, 10, iLineWidth, 10, 255, 255, 255, 255, 0 );
	
	// Get the target's origin
	new vOrigin[3]
	get_user_origin( iTarget, vOrigin );
	
	// Create an elight on the target
	Create_TE_ELIGHT( iTarget, vOrigin, 100, 255, 255, 255, 10, 0 );

	// Play the lightning sound
	emit_sound( iCaster, CHAN_STATIC, g_Sound[LIGHTNING_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );

	return;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
