// Sparta-Mod UtilMenus

// Show a player the utilmenu one
public ShowUtilMenuOne( id )
{
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// We need a var where we add the text for the menu
	new MenuText[512] = "", Key = 0;
	
	// We add the header
	formatex ( MenuText, charsmax( MenuText ), "\yUtilmenu 1\R$  Cost^n^n" );
	
	// We loop through every Menuitem and add this
	static i;
	for ( i = 0; i < MAX_UTILONE_ITEMS; ++i )
	{
		formatex ( MenuText, charsmax( MenuText ), "%s\w%d. %s\y\R%d^n", MenuText, ( i + 1 ), Util_One_Items[i], Util_One_Cost[i] );
		
		// add the key
		Key |= (1<<i)
	}
	
	// Add the exit button
	formatex ( MenuText, charsmax( MenuText ), "%s^n\w0. Exit^n", MenuText );
	
	// One key for the exit button
	Key |= (1<<9)
	
	// Show the player the menu
	show_menu ( id, Key, MenuText, 15, "UtilMenuOne" );
	
	return PLUGIN_CONTINUE;
}

// The player selected an Item from the Menu
public SelectUtilMenuOne( id, key )
{
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// He selects exit
	if ( key == 9 )
	{
		return PLUGIN_CONTINUE;
	}
	
	// We have to add one
	key++;
	
	// We check if the player has enough money and other things...
	static bool:DataCheck;
	DataCheck = CheckPlayerData( id, key );
	
	// It's allright
	if ( DataCheck )
	{
		// We save the result from the player
		Player_ItemData[id][UTILMENU_ONE] = key;
		
		// Allright. Give him a message
		ShowPlayerItemMessage( id, key );
		
		// We remove the money from the player
		cs_set_user_money( id, ( cs_get_user_money( id ) - Util_One_Cost[key-1] ), 1 );
		
		// Start the function from items
		HandleItems( id );
	}
	
	return PLUGIN_CONTINUE;
}

// Show the player a little message :>
ShowPlayerItemMessage( id, item )
{
	client_print( id, print_chat, "%s You have choosed %s. Have Fun!", SPARTA_NAME, Util_One_Items[item-1] );
}

// Check if the player has enough money and other things
bool:CheckPlayerData( id, item )
{
	// He has no enough money :(
	if ( cs_get_user_money( id ) < Util_One_Cost[item-1] )
	{
		client_print( id, print_center, "You have insufficient funds!" );
		return false;
	}
	
	// The player isn't alive
	if ( !is_user_alive( id ) && item != ITEM_REINCARNATION )
	{
		client_print( id, print_center, "You have to be alive to buy this item!" );
		return false;
	}
	
	// The round is over
	if ( g_RoundOver )
	{
		client_print( id, print_center, "The round is over!" );
		return false;
	}
	
	// It's allright
	return true;
}

// Handle the items
HandleItems( id )
{
	// Item reincarnation
	ITEM_Reincarnation( id );
	
	// Item Hegrenade
	ITEM_HeGrenade( id + TASK_NADE );
}

// Item Reincarnation
ITEM_Reincarnation( id )
{
	// The player isn't connected, okay
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// The player hasn't this item
	if ( Player_ItemData[id][UTILMENU_ONE] != ITEM_REINCARNATION )
	{
		return PLUGIN_CONTINUE;
	}
	
	// hoo? The player is alive. He get back his money
	if ( is_user_alive( id ) )
	{
		cs_set_user_money( id, ( cs_get_user_money( id ) + Util_One_Cost[ITEM_REINCARNATION-1] ), 1 );
	}
	
	// Spawn the player (from wc3ft)
	set_pev( id, pev_spawnflags, 3 );
	dllfunc( DLLFunc_Spawn, id );
	set_pev( id, pev_iuser1, 0 );
	
	// Remove the item from the player
	Player_ItemData[id][UTILMENU_ONE] = ITEM_NONE;
	
	return PLUGIN_CONTINUE;
}

// Item Hegrenade
ITEM_HeGrenade( id )
{
	id -= TASK_NADE;
	
	if ( !is_user_alive( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// The player hasn't this item
	new PlayerItem = Player_ItemData[id][UTILMENU_ONE]; 
	if ( PlayerItem != ITEM_NADEONE && PlayerItem != ITEM_NADETWO && PlayerItem != ITEM_NADETHREE )
	{
		return PLUGIN_CONTINUE;
	}
	
	// The player has allready a grenade
	if ( cs_get_user_bpammo( id, CSW_HEGRENADE ) > 0 )
	{
		return PLUGIN_CONTINUE;
	}
	
	// The player is alive. Give him a nade
	bacon_give_weapon ( id, "weapon_hegrenade" );
	
	return PLUGIN_CONTINUE;
}

// Slowdown poison
public ITEM_SlowDownPoison( idattacker, idvictim )
{
	// The attacker has the poison
	if ( Player_ItemData[idattacker][UTILMENU_ONE] == ITEM_SLOWDOWN )
	{
		// Poison aktiv?
		if ( random_float( 0.0, 1.0 ) <= POISON_CHANCE )
		{
			// Set him the maxspeed
			set_user_maxspeed( idvictim, float( SPEED_FOR_SKILL ) );
			
			// Play the poison sound
			emit_sound( idvictim, CHAN_STATIC, g_Sound[POISON_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
			
			// Print a message
			client_print( idvictim, print_chat, "%s You are infected with %s", SPARTA_NAME, Util_One_Items[ITEM_SLOWDOWN-1] );
			client_print( idattacker, print_chat, "%s You have the enemy infected with %s", SPARTA_NAME, Util_One_Items[ITEM_SLOWDOWN-1] );
			
			// Set a task to remove the poison
			set_task( 3.0, "RemovePoisen", ( idvictim + TASK_POISON ) );
		}
	}
	
	// The victim has the poison maybe too
	if ( Player_ItemData[idvictim][UTILMENU_ONE] == ITEM_SLOWDOWN )
	{
		if ( random_float( 0.0, 1.0 ) <= POISON_CHANCE )
		{
			// Set him the maxspeed
			set_user_maxspeed( idattacker, float( SPEED_FOR_SKILL ) );
			
			// Play the poison sound
			emit_sound( idattacker, CHAN_STATIC, g_Sound[POISON_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
			
			// Print a message
			client_print( idattacker, print_chat, "%s You are infected with %s", SPARTA_NAME, Util_One_Items[ITEM_SLOWDOWN-1] );
			client_print( idvictim, print_chat, "%s You have the enemy infected with %s", SPARTA_NAME, Util_One_Items[ITEM_SLOWDOWN-1] );
			
			// set a task to remove the poison
			set_task( 3.0, "RemovePoison", ( idattacker + TASK_POISON ) );
		}
	}
}

// Remove the poison from the enemy
public RemovePoison( id )
{
	id -= TASK_POISON;
	
	if ( !is_user_alive( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Set the maxspeed
	set_user_maxspeed( id, 1.0 );
	
	// Call the speed function
	set_task( 0.3, "Skill_SetSpeed", ( id + TASK_SPEED ) );
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
